res = 1

local canvas = {love.graphics.newCanvas(800, 600), love.graphics.newCanvas(800, 600)}

mask_canvas = love.graphics.newCanvas(800, 600, "normal", 0)
polygon_canvas = love.graphics.newCanvas(800, 600, "normal", 0)
local pv = [[extern float power; varying vec2 bc[14];
			vec4 position(mat4 transform_projection, vec4 vertex_position)
			{
				bc[ 0] = VaryingTexCoord.st + vec2(-0.028 * power, 0.0);
				bc[ 1] = VaryingTexCoord.st + vec2(-0.024 * power, 0.0);
				bc[ 2] = VaryingTexCoord.st + vec2(-0.020 * power, 0.0);
				bc[ 3] = VaryingTexCoord.st + vec2(-0.016 * power, 0.0);
				bc[ 4] = VaryingTexCoord.st + vec2(-0.012 * power, 0.0);
				bc[ 5] = VaryingTexCoord.st + vec2(-0.008 * power, 0.0);
				bc[ 6] = VaryingTexCoord.st + vec2(-0.004 * power, 0.0);
				bc[ 7] = VaryingTexCoord.st + vec2( 0.004 * power, 0.0);
				bc[ 8] = VaryingTexCoord.st + vec2( 0.008 * power, 0.0);
				bc[ 9] = VaryingTexCoord.st + vec2( 0.012 * power, 0.0);
				bc[10] = VaryingTexCoord.st + vec2( 0.016 * power, 0.0);
				bc[11] = VaryingTexCoord.st + vec2( 0.020 * power, 0.0);
				bc[12] = VaryingTexCoord.st + vec2( 0.024 * power, 0.0);
				bc[13] = VaryingTexCoord.st + vec2( 0.028 * power, 0.0);

				return transform_projection * vertex_position;
			}
	]]

local ph = [[extern float power; varying vec2 bc[14];
			vec4 position(mat4 transform_projection, vec4 vertex_position)
			{
				bc[ 0] = VaryingTexCoord.st + vec2(0.0, -0.028 * power);
				bc[ 1] = VaryingTexCoord.st + vec2(0.0, -0.024 * power);
				bc[ 2] = VaryingTexCoord.st + vec2(0.0, -0.020 * power);
				bc[ 3] = VaryingTexCoord.st + vec2(0.0, -0.016 * power);
				bc[ 4] = VaryingTexCoord.st + vec2(0.0, -0.012 * power);
				bc[ 5] = VaryingTexCoord.st + vec2(0.0, -0.008 * power);
				bc[ 6] = VaryingTexCoord.st + vec2(0.0, -0.004 * power);
				bc[ 7] = VaryingTexCoord.st + vec2(0.0,  0.004 * power);
				bc[ 8] = VaryingTexCoord.st + vec2(0.0,  0.008 * power);
				bc[ 9] = VaryingTexCoord.st + vec2(0.0,  0.012 * power);
				bc[10] = VaryingTexCoord.st + vec2(0.0,  0.016 * power);
				bc[11] = VaryingTexCoord.st + vec2(0.0,  0.020 * power);
				bc[12] = VaryingTexCoord.st + vec2(0.0,  0.024 * power);
				bc[13] = VaryingTexCoord.st + vec2(0.0,  0.028 * power);

				return transform_projection * vertex_position;
			}
	]]

local blur = [[extern float power; varying vec2 bc[14];
			vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
			{
				vec4 texcolor = vec4(0.0);
				texcolor += Texel(texture, bc[ 0]) * 0.0044299121055113265;
				texcolor += Texel(texture, bc[ 1]) * 0.00895781211794;
				texcolor += Texel(texture, bc[ 2]) * 0.0215963866053;
				texcolor += Texel(texture, bc[ 3]) * 0.0443683338718;
				texcolor += Texel(texture, bc[ 4]) * 0.0776744219933;
				texcolor += Texel(texture, bc[ 5]) * 0.115876621105;
				texcolor += Texel(texture, bc[ 6]) * 0.147308056121;
				texcolor += Texel(texture, texture_coords) * 0.159576912161;
				texcolor += Texel(texture, bc[ 7]) * 0.147308056121;
				texcolor += Texel(texture, bc[ 8]) * 0.115876621105;
				texcolor += Texel(texture, bc[ 9]) * 0.0776744219933;
				texcolor += Texel(texture, bc[10]) * 0.0443683338718;
				texcolor += Texel(texture, bc[11]) * 0.0215963866053;
				texcolor += Texel(texture, bc[12]) * 0.00895781211794;
				texcolor += Texel(texture, bc[13]) * 0.0044299121055113265;

				return texcolor;// * color;
			}
	]]

local hblur = love.graphics.newShader(blur, ph)
local vblur = love.graphics.newShader(blur, pv)

function love.load()
	love.graphics.setBackgroundColor(40, 40, 40, 255)

	power = 1
	hblur:send("power", power)
	vblur:send("power", power)

	segs = 8

	createMirrorBezier()

	r = love.math.random(255)
	g = love.math.random(255)
	b = love.math.random(255)
	a = love.math.random(255)
	r2 = love.math.random(255)
	g2 = love.math.random(255)
	b2 = love.math.random(255)
	a2 = love.math.random(255)

	x = 400
	y = 300
	
	x = 100; y = 100; r = 20; w = 200; h = 100
	roundrect(x, y, w, h, r)

end

function love.update(dt)
	if love.keyboard.isDown("up") then
		power = power + 0.01
		hblur:send("power", power)
		vblur:send("power", power)
	end
	if love.keyboard.isDown("down") then
		power = power - 0.01
		hblur:send("power", power)
		vblur:send("power", power)
	end
end

function stencil()
	love.graphics.polygon("fill", coords)
end

function love.draw()
	canvas[1]:clear()
	canvas[2]:clear()

	love.graphics.setColor(r, g, b, 255)
	love.graphics.polygon("fill", coords)

	love.graphics.setCanvas(canvas[1])
	love.graphics.setColor(r2, g2, b2, 255)
	love.graphics.polygon("fill", coords)

	love.graphics.setCanvas(canvas[2])
	love.graphics.setShader(hblur)
	love.graphics.draw(canvas[1])

	love.graphics.setCanvas()
	love.graphics.setStencil(stencil)
	love.graphics.setShader(vblur)
	love.graphics.draw(canvas[2])

	love.graphics.setShader()
	love.graphics.setStencil()

	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.line(coords)

	love.graphics.setColor(255, 0, 0, 255)

	love.graphics.setColor(255, 0, 0, 255)
	for i = 1, #tbl do
		love.graphics.push()
		love.graphics.translate(tbl[i].x, tbl[i].y)
		love.graphics.rotate(tbl[i].angle)
		love.graphics.rectangle("fill", -10, -10, 20, 20)
		love.graphics.pop()
	end

	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print('Press "Escape" to quit', 200, 400)
	love.graphics.print('Press "Insert" to create random mirrored shape', 200, 420)
	love.graphics.print('Press "Up" to increase blur power', 200, 440)
	love.graphics.print('Press "Down" to decrease blur power', 200, 460)
	love.graphics.print('Press "Page Up" to increase number of markers', 200, 480)
	love.graphics.print('Press "Page Down" to decrease number of markers', 200, 500)
	love.graphics.print('Press "Home / End" to change shape colors', 200, 520)

	pnt2 = {}
	
--	love.graphics.setColor(255, 255, 255, 255)

	pnt2[ 1] = x + r;			pnt2[ 2] = y
	pnt2[ 3] = x + w - r;	pnt2[ 4] = y
	pnt2[ 5] = x + w;			pnt2[ 6] = y + r
	pnt2[ 7] = x + w;			pnt2[ 8] = y + h - r
	pnt2[ 9] = x + w - r;	pnt2[10] = y + h
	pnt2[11] = x + r;			pnt2[12] = y + h
	pnt2[13] = x;				pnt2[14] = y + h - r
	pnt2[15] = x;				pnt2[16] = y + r

--	love.graphics.polygon("fill", pnt2)

--	love.graphics.setColor(255, 0, 0, 255)
--	love.graphics.line(rrr)

	love.graphics.setColor(255, 255, 0, 255)
	love.graphics.print(res, 100, 400)

--	love.graphics.line(x + r, y, x + w - r, y, x + w, y + r, x + w, y + h - r, x + w - r, y + h, x + r, y + h, x, y + h - r, x, y + r)


	love.graphics.setCanvas(mask_canvas)
	mask_canvas:clear()
	love.graphics.setColor(0, 0, 0, 64)
	love.graphics.polygon("fill", rrr)
	love.graphics.setColor(0, 0, 0, 64)
	love.graphics.polygon("fill", rrr2)

	local mask = [[
			vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
			{
				if(Texel(texture, texture_coords).a > 0.4 && Texel(texture, texture_coords).a < 0.5 || Texel(texture, texture_coords).a > 0.6)
					return vec4(0.0, 0.0, 0.0, 0.0);
				return color;
			}
	]]
	love.graphics.setCanvas(polygon_canvas)
	polygon_canvas:clear()
	love.graphics.setStencil(limit)
	love.graphics.setShader(love.graphics.newShader(mask))
	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.draw(mask_canvas)
	love.graphics.setShader()
	love.graphics.setStencil()

	love.graphics.setCanvas()
	love.graphics.draw(polygon_canvas)

	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.setLineWidth(2)
	love.graphics.line(rrr)

	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.setLineWidth(2)
	love.graphics.line(rrr2)

	love.graphics.setColor(0, 0, 255, 128)
	love.graphics.line(unpack(pnt, 1, 4))
	love.graphics.line(unpack(pnt, 5, 8))

	love.graphics.setColor(0, 0, 255, 128)
	love.graphics.line(unpack(pnt3, 1, 4))
	love.graphics.line(unpack(pnt3, 5, 8))


	love.graphics.setColor(255, 255, 0, 255)
	for i = 1, #pnt, 2 do love.graphics.circle("fill", pnt[i], pnt[i + 1], 5) end

	love.graphics.setColor(255, 255, 0, 255)
	for i = 1, #pnt3, 2 do love.graphics.circle("fill", pnt3[i], pnt3[i + 1], 5) end

end

function limit()
	love.graphics.polygon("fill", rrr)
	love.graphics.polygon("fill", rrr2)
end

function getclosestpoint(x, y)

	max = 10000
 	for i = 1, #pnt - 1, 2 do
		m = ((x - pnt[i]) ^ 2 + (y - pnt[i + 1]) ^ 2) ^ 0.5
		if m < max then
			shape = pnt
			res = i
			max = m
		end
	end

 	for i = 1, #pnt3 - 1, 2 do
		m = ((x - pnt3[i]) ^ 2 + (y - pnt3[i + 1]) ^ 2) ^ 0.5
		if m < max then
			shape = pnt3
			res = i
			max = m
		end
	end

	return res, shape

end

function love.mousemoved(x, y, dx, dy)

	if love.mouse.isDown('r') then
		p,s = getclosestpoint(x, y)
		
		if p == 1 or p == 7 then
			pnt[p] = x; pnt[p + 1] = y
			pnt3[p] = x; pnt3[p + 1] = y
		else
			s[p] = x; s[p + 1] = y
		end

		rrr = love.math.newBezierCurve(pnt):render(8)
		rrr2 = love.math.newBezierCurve(pnt3):render(8)

	end
end

function fillpath(points)

	polygon = {}

	j = 1
	for i = 1, #points, 2 do
		polygon[j] = points[i]
		polygon[j + 1] = points[i + 1]
	end

	love.graphics.polygon("fill", polygon)

end

function roundrect(x, y, w, h, r)

	k = 0.551915024 * r --k = 0.552228474 * r 

--	rr = love.math.newBezierCurve(x, y + r, x + k, y + r, x + r, y + k, x + r, y, x + r, y, x + r, h)

	pnt = {}
	pnt3 = {}
	
	pnt3[ 1] = x + 210;				pnt3[ 2] = y + 40
	pnt3[ 3] = x + 20;				pnt3[ 4] = y + 120
	pnt3[ 5] = x + 230;				pnt3[ 6] = y + 30
	pnt3[ 7] = x + 40;				pnt3[ 8] = y + 140


	pnt[ 1] = x + r;				pnt[ 2] = y
	pnt[ 3] = x + r;				pnt[ 4] = y + 20
	pnt[ 5] = x + r;				pnt[ 6] = y + 30
	pnt[ 7] = x + r;				pnt[ 8] = y + 40
--	pnt[ 9] = x + r;				pnt[10] = y + 40

--[[	pnt[ 5] = x + w - r;			pnt[ 6] = y
	pnt[ 7] = x + w - r;			pnt[ 8] = y

	pnt[ 9] = x + w - r + k;	pnt[ 10] = y

	pnt[ 11] = x + w;				pnt[ 12] = y + r - k

	pnt[ 13] = x + w;				pnt[14] = y + r
	pnt[ 13] = x + w;				pnt[14] = y + r

	pnt[15] = x + w;				pnt[16] = y + h - r
	pnt[13] = x + w - r;	pnt[14] = y + h
	pnt[15] = x + r;		pnt[16] = y + h
	pnt[17] = x;			pnt[18] = y + h - r
	pnt[19] = x;			pnt[20] = y + r
]]

	rrr = love.math.newBezierCurve(pnt):render(8)
	rrr2 = love.math.newBezierCurve(pnt):render(8)

end

function getAngle(x1, y1, x2, y2)
	return math.atan2(x2 - x1, y2 - y1)
end
	
function even(points, num)
	tbl = {}

	lengths = {}
	len = 0
	love.graphics.setColor(0, 0, 0, 255)
	j = 1
	for i = 1, #points - 2, 2 do
		lengths[j] = {}
		lengths[j].coord = i
		lengths[j].length = getLength(points[i], points[i + 1], points[i + 2], points[i + 3])
		len = len + lengths[j].length
		j = j + 1
	end

	length = len / num

	tbl[1] = {}
	tbl[1].x = points[1]
	tbl[1].y = points[2]
	tbl[1].angle = getAngle(points[1], points[2], points[3], points[4])
	curlen = 0
	tb = 2
	for i = 1, #lengths - 4 do
		if length > curlen + lengths[i].length then
			curlen = curlen + lengths[i].length
		else
			tbl[tb] = {}
			tbl[tb].x, tbl[tb].y = getPoint(length - curlen, points[lengths[i].coord], points[lengths[i].coord + 1], points[lengths[i].coord + 2], points[lengths[i].coord + 3])
			tbl[tb].angle = getAngle(points[lengths[i + 4].coord], points[lengths[i].coord + 5], points[lengths[i].coord + 6], points[lengths[i].coord + 7])
			curlen = length - curlen
			tb = tb + 1
		end
	end
end

function createMirrorBezier()
	t = {}
	for i = 1, 4 do
		t[i] = {}
		if i == 1 then nextx = 0 else nextx = t[i - 1].x end
		t[i].x = love.math.random(nextx, 399)
		if i == 1 then nexty = 0 else nexty = t[i - 1].y end
		t[i].y = love.math.random(nexty, 299)		
	end

	t[5] = {}
	t[6] = {}
	t[7] = {}
	t[8] = {}
	t[5].x = 799 - t[4].x
	t[5].y = t[4].y
	t[6].x = 799 - t[3].x
	t[6].y = t[3].y
	t[7].x = 799 - t[2].x
	t[7].y = t[2].y
	t[8].x = 799 - t[1].x
	t[8].y = t[1].y

	curve = love.math.newBezierCurve(399, 20, t[1].x, t[1].y, t[2].x, t[2].y, t[3].x, t[3].y, t[4].x, t[4].y, t[5].x, t[5].y, t[6].x, t[6].y, t[7].x, t[7].y, t[8].x, t[8].y, 399, 20)
	coords = curve:render(8)

	even(coords, segs)
end

function getLength(x1, y1, x2, y2)
	return math.sqrt((x1 - x2) ^ 2 + (y1 - y2) ^ 2)
end

function getPoint(n, x1, y1, x2, y2)
	d = math.sqrt((x1 - x2) ^ 2 + (y1 - y2) ^ 2)
	r = n / d
	return r * x2 + (1 - r) * x1, r * y2 + (1 - r) * y1
end

function love.keypressed(key, isRepeat)
	if key == "escape" then
		love.event.quit()
	end
	if key == "pageup" then
		segs = segs + 1
		even(coords, segs)
	end
	if key == "pagedown" then
		segs = segs - 1
		if segs == 0 then segs = 1 end
		even(coords, segs)
	end
	if key == "home" then
		r = love.math.random(255)
		g = love.math.random(255)
		b = love.math.random(255)
		a = love.math.random(255)
	end
	if key == "end" then
		r2 = love.math.random(255)
		g2 = love.math.random(255)
		b2 = love.math.random(255)
		a2 = love.math.random(255)
	end
	if key == "insert" then
		createMirrorBezier()
	end
end
